## AMPL model file for portfolio optimization ##

set A;

param R;
param mu0;
param wmin;
param C {i in A,j in A};
param mu {j in A};

var w0;
var w {j in A};
var z {j in A} binary;

minimize Risk: sum {i in A} w[i] * (sum {j in A} C[i,j]*w[j]);

subject to Budget: (sum {j in A} w[j]) + w0 == 1;

subject to Returns: (sum {j in A} mu[j]*w[j]) + w0 * mu0 >= R;

subject to MinInvestment1 {j in A}: z[j]*wmin <= w[j];

subject to MinInvestment2 {j in A}: w[j] <= z[j];